﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using GalaSoft.MvvmLight;
using System.Collections.ObjectModel;
using GalaSoft.MvvmLight.Command;

using VirtualOlympus.Behaviors;

namespace VirtualOlympus.WPF.Behaviors.UI
{
    public class MainWindowViewModel : ViewModelBase
    {
        public class DemoClass
        {
            public DemoClass(string field1, string field2, string field3)
            {
                Field1 = field1;
                Field2 = field2;
                Field3 = field3;
            }

            public string Field1 { get; set; }
            public string Field2 { get; set; }
            public string Field3 { get; set; }

            public DemoClass Clone()
            {
                return new DemoClass(this.Field1, this.Field2, this.Field3);
            }
        }

        public MainWindowViewModel()
        {
            Items = new ObservableCollection<DemoClass>(new DemoClass[] {
                new DemoClass("Item 1.1", "Item 1.2", "Item 1.3"),
                new DemoClass("Item 2.1", "Item 2.2", "Item 2.3"),
                new DemoClass("Item 3.1", "Item 3.2", "Item 3.3"),
                new DemoClass("Item 4.1", "Item 4.2", "Item 4.3"),
                new DemoClass("Item 5.1", "Item 5.2", "Item 5.3"),
                new DemoClass("Item 6.1", "Item 6.2", "Item 6.3"),
            });

            ItemsDragDropCommand = new RelayCommand<DataGridDragDropEventArgs>((args) => DragDropItem(args), (args) => args != null && args.TargetObject != null && args.DroppedObject != null && args.Effects != System.Windows.DragDropEffects.None);
        }

        public ObservableCollection<DemoClass> Items { get; private set; }

        public RelayCommand<DataGridDragDropEventArgs> ItemsDragDropCommand { get; private set; }

        public void DragDropItem(DataGridDragDropEventArgs args)
        {
            int targetIndex = Items.IndexOf((DemoClass)args.TargetObject);
            if (args.Direction == DataGridDragDropDirection.Down) targetIndex++;

            if (args.Effects == System.Windows.DragDropEffects.Move)
            {
                int sourceIndex = Items.IndexOf((DemoClass)args.DroppedObject);
                if (sourceIndex < targetIndex) targetIndex--;
                Items.Remove((DemoClass)args.DroppedObject);

                Items.Insert(targetIndex, (DemoClass)args.DroppedObject);
            }
            else if (args.Effects == System.Windows.DragDropEffects.Copy)
            {
                Items.Insert(targetIndex, ((DemoClass)args.DroppedObject).Clone());
            }
        }
    }
}
